/*****************************************************************************
 * emac_clock_en.c
 *****************************************************************************/
#include <sysreg.h>
#include <cdefBF609.h>
#include <sys/exception.h>
#include <sys/excause.h>
#include <signal.h>
#include <stdio.h>

#define PRESCALE 20

#define TWI_ADDR 0x21

#define CLKDIV_HI (25 << 8)
#define CLKDIV_LO 25

#define MCP_ADD_IOIDIRA   0x00
#define MCP_DAT_IOIDIRA   0x00
#define MCP_ADD_IOLATA    0x14
#define MCP_DAT_IOLATA    0x01

#define Data_count 2
#define DATA_CNT ( Data_count << 6)

void enable_lp_ezkit()
{

	Init_TWI0();

	config_MCP_IOIDIRA();

	wait_completion();

	config_MCP_IOLATA();

	wait_completion();

}

void wait_completion()
{
	int check_mcomp = 0;

	while(!check_mcomp)
	{

		check_mcomp  = 		*pREG_TWI0_ISTAT;
		check_mcomp &= 		BITM_TWI_ISTAT_MCOMP;

		asm("ssync;");
	}


	*pREG_TWI0_ISTAT |= 	BITM_TWI_ISTAT_TXSERV;
		asm("ssync;");

	*pREG_TWI0_ISTAT |= 	BITM_TWI_ISTAT_MCOMP;
		asm("ssync;");

}


/************ MASTER Initialization *********************************************/

void Init_TWI0(void)
{

	*pREG_TWI0_CTL= 		BITM_TWI_CTL_EN | PRESCALE;
		asm("ssync;");

	*pREG_TWI0_CLKDIV= 		CLKDIV_HI | CLKDIV_LO;
		asm("ssync;");

	*pREG_TWI0_MSTRADDR= 	TWI_ADDR;
		asm("ssync;");

	*pREG_TWI0_FIFOCTL= 	BITM_TWI_FIFOCTL_RXFLUSH | BITM_TWI_FIFOCTL_TXFLUSH;
		asm("ssync;");

	*pREG_TWI0_IMSK = 		BITM_TWI_IMSK_RXSERV | BITM_TWI_IMSK_TXSERV | BITM_TWI_IMSK_MERR | BITM_TWI_IMSK_MCOMP;
		asm("ssync;");

	*pREG_TWI0_FIFOCTL= 	2<<BITP_TWI_FIFOCTL_RXILEN  | 2<<BITP_TWI_FIFOCTL_TXILEN;
		asm("ssync;");

}

void config_MCP_IOIDIRA()
{
	// Pre Load the FIFO
	*pREG_TWI0_TXDATA8 = 	MCP_ADD_IOIDIRA;
		asm("ssync;");

	*pREG_TWI0_TXDATA8 = 	MCP_DAT_IOIDIRA;
		asm("ssync;");

	*pREG_TWI0_MSTRCTL =    DATA_CNT | BITM_TWI_MSTRCTL_EN;
		asm("ssync;");

}

void config_MCP_IOLATA()
{
	// Pre Load the FIFO
	*pREG_TWI0_TXDATA8 = 	MCP_ADD_IOLATA;
		asm("ssync;");

	*pREG_TWI0_TXDATA8 = 	MCP_DAT_IOLATA;
		asm("ssync;");

	*pREG_TWI0_MSTRCTL =    DATA_CNT | BITM_TWI_MSTRCTL_EN;
		asm("ssync;");

}


