/*****************************************************************************
 * SCB_Optimization_Core0.c
 *****************************************************************************/

#include <ccblkfn.h>
#include "adi_initialize.h"
#include "SCB_Optimization_Core0.h"
#include "cgu_init.h"

// Global variable test case completion
bool done = true;


int mdma_counter0 ;
int mdma_counter1 ;
int mdma_counter2 ;
int mdma_counter3 ;


int main(void)
{
	/* Initialize managed drivers and/or services */
	adi_initComponents();

	/**
	 * The default startup code does not include any functionality to allow
	 * core 0 to enable core 1. A convenient way to enable core 1 is to use the
	 * 'adi_core_1_enable' function. 
	 */
//	adi_core_1_enable();

	//Initialize PLL-CCLK=500 MHz, SYSCLK=250MHz, SCLK0=SCLK1=125MHz, DDR CLK = 250MHz
	CGU_Init(20, 1, 2);

#ifdef DEBUG
#ifdef SDRAM
	char  mem_ary[] = "SDRAM";
#else
#ifdef  L2
	char  mem_ary[] = "L2";
#else L1
	char  mem_ary[] = "L1";
#endif
#endif
	printf ("Executing Test Case# %d \n", TEST_CASE);
	printf ("Buffer in Memory %s \n", mem_ary);
#endif

	// Initialize timer
	 timer_init();

	// Initialize DMA
	 mdma_init();

	// SCB configuration
	 scb_init();

	 /* Enable timer */
 	*pTCNTL |= BITM_TCNTL_EN;

	// Enable DMA
	*pREG_DMA21_CFG 	|= ENUM_DMA_CFG_EN;
	*pREG_DMA22_CFG 	|= ENUM_DMA_CFG_EN;

	*pREG_DMA23_CFG 	|= ENUM_DMA_CFG_EN;
	*pREG_DMA24_CFG 	|= ENUM_DMA_CFG_EN;

	*pREG_DMA25_CFG 	|= ENUM_DMA_CFG_EN;
	*pREG_DMA26_CFG 	|= ENUM_DMA_CFG_EN;
	*pREG_DMA27_CFG 	|= ENUM_DMA_CFG_EN;
	*pREG_DMA28_CFG 	|= ENUM_DMA_CFG_EN;


	// Run
	while (done) ;

	// Total Bytes x'fer = MDMA_counter* BUFF_SIZE(1024) bytes * Number of DMA channels
	// Print statistics
	printf ("MDMA0 = %.2f MB/sec, Number of Buff = %d \n", 2*(float)(mdma_counter0)/1024, mdma_counter0);
	printf ("MDMA1 = %.2f MB/sec, Number of Buff = %d \n", 2*(float)mdma_counter1/1024, mdma_counter1);
	printf ("MDMA2 = %.2f MB/sec, Number of Buff = %d \n", 2*(float)mdma_counter2/1024, mdma_counter2);
	printf ("MDMA3 = %.2f MBb/sec, Number of Buff = %d \n", 2*(float)mdma_counter3/1024, mdma_counter3);
	return 0;
}

