/*****************************************************************************
 * Stress_Test1_Core0.h
 *****************************************************************************/

#ifndef __STRESS_TEST1_CORE0_H__
#define __STRESS_TEST1_CORE0_H__

#define ENABLE_PPI0_DMA_187_5MBPS
#define ENABLE_PPI1_DMA_125MBPS
#define ENABLE_PPI2_DMA_125MBPS
#define ENABLE_MDMA0_DMA_500MBPS
#define ENABLE_MDMA2_DMA_500MBPS
#define ENABLE_LP0_LP1_DMA_62_5MBPS


#define PAGE_SIZE 2048
#define ROWS_PER_BANK 8192
#define BANK_SIZE PAGE_SIZE*ROWS_PER_BANK


//#define USE_SINGLE_BANK

//T1
#define USE_MULTIPLE_BANKS


//T2
//#define LIMIT_MDMA0_BW 160
//#define LIMIT_MDMA2_BW 160

//T3
#define LIMIT_MDMA0_BW 175
#define LIMIT_MDMA2_BW 175
#define LOWER_LPCLK_SPEED


#define SCB_OPTIMIZATION

#ifdef USE_MULTIPLE_BANKS
	#define PPI0_DMA_DMC_START_ADDRESS  0*BANK_SIZE
	#define PPI1_DMA_DMC_START_ADDRESS  1*BANK_SIZE
	#define PPI2_DMA_DMC_START_ADDRESS  2*BANK_SIZE
	#define MDMA0_DMA_DMC_START_ADDRESS 3*BANK_SIZE
	#define MDMA2_DMA_DMC_START_ADDRESS 4*BANK_SIZE
	#define LP0_DMA_DMC_START_ADDRESS 	5*BANK_SIZE
#endif

#ifdef USE_SINGLE_BANK
	#define PPI0_DMA_DMC_START_ADDRESS 	0*2048
	#define PPI1_DMA_DMC_START_ADDRESS 	4*1*PAGE_SIZE

	#ifdef PPI0_PPI1_IN_DIFFERENT_BANKS
		#define PPI2_DMA_DMC_START_ADDRESS 	2*BANK_SIZE
	#else
		#define PPI2_DMA_DMC_START_ADDRESS 	4*2*PAGE_SIZE
	#endif

	#define MDMA0_DMA_DMC_START_ADDRESS 4*3*PAGE_SIZE
	#define MDMA2_DMA_DMC_START_ADDRESS 4*4*PAGE_SIZE
	#define LP0_DMA_DMC_START_ADDRESS   4*5*PAGE_SIZE
#endif


#define MDMA0_DMA_L2_START_ADDRESS  0xC8080000+4*PAGE_SIZE
#define MDMA2_DMA_L2_START_ADDRESS  0xC8080000


#define SOURCE_MDMA_CHANNEL 23
#define DEST_MDMA_CHANNEL 24

#define SOURCE_PSIZE_MDMA0 4
#define DEST_PSIZE_MDMA0   4
#define SOURCE_MSIZE_MDMA0 32
#define DEST_MSIZE_MDMA0   32
#define SOURCE_DMA_CFG_MDMA0 ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_PSIZE04|ENUM_DMA_CFG_XCNT_INT|ENUM_DMA_CFG_AUTO
#define DEST_DMA_CFG_MDMA0 BITM_DMA_CFG_WNR|ENUM_DMA_CFG_PSIZE04|ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_XCNT_INT|ENUM_DMA_CFG_AUTO

#define SOURCE_PSIZE_MDMA2 4
#define DEST_PSIZE_MDMA2   4
#define SOURCE_MSIZE_MDMA2 32
#define DEST_MSIZE_MDMA2   32
#define SOURCE_DMA_CFG_MDMA2 ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_PSIZE04|ENUM_DMA_CFG_XCNT_INT|ENUM_DMA_CFG_AUTO
#define DEST_DMA_CFG_MDMA2 BITM_DMA_CFG_WNR|ENUM_DMA_CFG_PSIZE04|ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_XCNT_INT|ENUM_DMA_CFG_AUTO

#define PPI0_PSIZE 4
#define PPI0_MSIZE 32
#define PPI0_DMA_CFG ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_PSIZE04|ENUM_DMA_CFG_XCNT_INT|ENUM_DMA_CFG_AUTO

#define PPI1_PSIZE 4
#define PPI1_MSIZE 32
#define PPI1_DMA_CFG ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_PSIZE04|ENUM_DMA_CFG_XCNT_INT|ENUM_DMA_CFG_AUTO

#define PPI2_PSIZE 4
#define PPI2_MSIZE 32
#define PPI2_DMA_CFG ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_PSIZE04|ENUM_DMA_CFG_XCNT_INT|ENUM_DMA_CFG_AUTO

#define CCLK_SPEED 500
#define SCLK_SPEED 125

#define MAX_SIZE 4*PAGE_SIZE

#define EPPI0_CTL_CFG ENUM_EPPI_CTL_TXMODE|ENUM_EPPI_CTL_NON656|ENUM_EPPI_CTL_INTCLK|ENUM_EPPI_CTL_INTFS|ENUM_EPPI_CTL_DLEN24|ENUM_EPPI_CTL_PACK_EN|ENUM_EPPI_CTL_EN
#define EPPI0_CTL2_CFG 0

#define EPPI1_CTL_CFG ENUM_EPPI_CTL_TXMODE|ENUM_EPPI_CTL_NON656|ENUM_EPPI_CTL_INTCLK|ENUM_EPPI_CTL_INTFS|ENUM_EPPI_CTL_DLEN16|ENUM_EPPI_CTL_PACK_EN|ENUM_EPPI_CTL_EN
#define EPPI1_CTL2_CFG 0

#define EPPI2_CTL_CFG ENUM_EPPI_CTL_TXMODE|ENUM_EPPI_CTL_NON656|ENUM_EPPI_CTL_INTCLK|ENUM_EPPI_CTL_INTFS|ENUM_EPPI_CTL_DLEN16|ENUM_EPPI_CTL_PACK_EN|ENUM_EPPI_CTL_EN
#define EPPI2_CTL2_CFG 0

#endif /* __STRESS_TEST1_CORE0_H__ */
